#ifndef Tele_h
#define Tele_h

//==================//
#include <string>
//==================//
#include <TROOT.h>
#include <TChain.h>
#include <TFile.h>
#include <TH2.h>
#include <TStyle.h>
#include <TCanvas.h>
#include <iostream>
#include <fstream>
#include <TRandom3.h>
//==================
#include "Hit.hh"

using namespace std;
class Tele 
{
public :
	Tele(Int_t runnum, TString RootPath, TString TelePath);
	virtual ~Tele();
	virtual void Init();
	virtual void Clear();
	virtual void Loop(Int_t maxnevt=-1);
	virtual void ReadPar(const char *filename,Double_t par[][2],Int_t n);
	virtual void MappingDSSD();
	virtual void MappingSSSD();
	virtual void MappingSSD();

private :
	Int_t fFileID;
	TFile *pRootFile;
	TTree *pRootTree;
	TFile *pTeleFile;
	TTree *pTeleTree;
	TRandom3 rnd3;
	DSSD *r2t1;
	DSSD *r2t2;
	DSSD *l2t1;
	DSSD *l2t2;
	SSSD *r1t1;
	SSSD *r1t2;
	SSSD *l1t1;
	SSSD *l1t2;
	SSD *r3t1;
	SSD *r3t2;
	SSD *l3t1;
	SSD *l3t2;

	Int_t tCoin;
	Int_t tDTM2;
	Int_t tT2db;
	Int_t tT1db;

	// For DSSD
	Double_t r2t1_xpar[32][2];
	Double_t r2t1_ypar[32][2];

	Double_t r2t2_xpar[32][2];
	Double_t r2t2_ypar[32][2];

	Double_t l2t1_xpar[32][2];
	Double_t l2t1_ypar[32][2];

	Double_t l2t2_xpar[32][2];
	Double_t l2t2_ypar[32][2];	
	// For SSSD
	Double_t r1t1_xpar[16][2];
	Double_t r1t2_xpar[16][2];
	Double_t l1t1_xpar[16][2];
	Double_t l1t2_xpar[16][2];

	// For SSD
	Double_t r3t1_par[1][2];
	Double_t r3t2_par[1][2];
	Double_t l3t1_par[1][2];
	Double_t l3t2_par[1][2];

private :
	//root file
   // Declaration of leaf types
   Int_t           ahit;
   Int_t           amod[500];   //[ahit]
   Int_t           ach[500];   //[ahit]
   Int_t           aval[500];   //[ahit]
   Int_t           adc[3][32];
   Int_t           acnt[3];
   Int_t           mhit;
   Int_t           mmod[500];   //[mhit]
   Int_t           mch[500];   //[mhit]
   Int_t           mval[500];   //[mhit]
   Int_t           madc[8][32];
   Int_t           mcnt[8];
   Int_t           ghit;
   Int_t           gmod[2];   //[ghit]
   Int_t           gch[2];   //[ghit]
   Int_t           gval[2];   //[ghit]
   Int_t           gdc[2][128][20];
   Int_t           gmulti[2][128];
   Int_t           gcnt[2];
   Int_t           shit;
   Int_t           smod[16];   //[shit]
   Int_t           sch[16];   //[shit]
   ULong64_t       sval[16];   //[shit]
   ULong64_t       sdc[32];
   Long64_t        nevt;

   // List of branches
   TBranch        *b_ahit;   //!
   TBranch        *b_amod;   //!
   TBranch        *b_ach;   //!
   TBranch        *b_aval;   //!
   TBranch        *b_adc;   //!
   TBranch        *b_acnt;   //!
   TBranch        *b_mhit;   //!
   TBranch        *b_mmod;   //!
   TBranch        *b_mch;   //!
   TBranch        *b_mval;   //!
   TBranch        *b_madc;   //!
   TBranch        *b_mcnt;   //!
   TBranch        *b_ghit;   //!
   TBranch        *b_gmod;   //!
   TBranch        *b_gch;   //!
   TBranch        *b_gval;   //!
   TBranch        *b_gdc;   //!
   TBranch        *b_gmulti;   //!
   TBranch        *b_gcnt;   //!
   TBranch        *b_shit;   //!
   TBranch        *b_smod;   //!
   TBranch        *b_sch;   //!
   TBranch        *b_sval;   //!
   TBranch        *b_sdc;   //!
   TBranch        *b_nevt;   //!

};
#endif



