#include "Hit.hh"

DSSD::DSSD()
{
	Clear();
}

void DSSD::Clear()
{
	memset(x,0,sizeof(x));
	memset(y,0,sizeof(y));
	memset(xe,0,sizeof(xe));
	memset(ye,0,sizeof(ye));
	memset(theta,0,sizeof(theta));
	memset(phi,0,sizeof(phi));

	for(Int_t i=0;i<3;i++)
	{
		xp[i]=-1;
		yp[i]=-1;
	}

	for(Int_t i=0;i<32;i++)
	{
		xt[i]=-9999;
		yt[i]=-9999;
	}
}

void DSSD::HitEP(Double_t distmp, Double_t thetatmp, Double_t phitmp)
{
	Int_t id[32];
	TMath::Sort(32,x,id);
	xe[0]=x[id[0]];		xp[0]=id[0];
	xe[1]=x[id[1]];		xp[1]=id[1];
	xe[2]=x[id[2]];		xp[2]=id[2];
	
	TMath::Sort(32,y,id);
	ye[0]=y[id[0]];		yp[0]=id[0];
	ye[1]=y[id[1]];		yp[1]=id[1];
	ye[2]=y[id[2]];		yp[2]=id[2];
	if(distmp<0.)
	{
		return;	
	}else
	{
		thetatmp=thetatmp*3.14159/180.;
		phitmp=phitmp*3.14159/180.;
	}
	
	TVector3 Vcenter;
	Vcenter.SetMagThetaPhi(distmp,thetatmp,phitmp);
	TVector3 vHit(0.,0.,0.);
	for(Int_t i=0;i<3;i++)
	{
		vHit.SetXYZ((16-xp[i])*2.-1.,(16-yp[i])*2.-1.,0.);
		if(cos(phitmp)>0.)
		{
			vHit.RotateY(thetatmp);
		}else
		{
			vHit.RotateY(-thetatmp);
		}
		vHit=Vcenter+vHit;
		theta[i]=vHit.Theta()*180./3.14159;
		phi[i]=vHit.Phi()*180./3.14159;
	}
}

SSSD::SSSD()
{
	Clear();
}

void SSSD::Clear()
{
	memset(x,0,sizeof(x));
	memset(xe,0,sizeof(xe));
	memset(theta,0,sizeof(theta));

	for(Int_t i=0;i<3;i++)
	{
		xp[i]=-1;
	}
	for(Int_t i=0;i<16;i++)
	{
		xt[i]=-9999;
	}
}

void SSSD::HitEP(Double_t distmp, Double_t thetatmp, Double_t phitmp)
{
	Int_t id[16];
	TMath::Sort(16,x,id);
	xe[0]=x[id[0]];		xp[0]=id[0];
	xe[1]=x[id[1]];		xp[1]=id[1];
	xe[2]=x[id[2]];		xp[2]=id[2];

	TVector3 Vcenter;
	Vcenter.SetMagThetaPhi(distmp,thetatmp,phitmp);
	TVector3 vHit(0.,0.,0.);
	for(Int_t i=0;i<3;i++)
	{
		vHit.SetXYZ((xp[i]-7)*3.-1.5,0.,0.);//????????????liuqiang define,not be checked!!
		if(cos(phitmp)>0.)
		{
			vHit.RotateY(thetatmp);
		}else
		{
			vHit.RotateY(-thetatmp);
		}
		vHit=Vcenter+vHit;
		theta[i]=vHit.Theta();
	}
}

SSD::SSD()
{
	Clear();
}

void SSD::Clear()
{
	xe=0;
}


